/*
 * MosP - Mind Open Source Project         http://www.mosp.jp/
 * Copyright (C) 1987-2008 MIND Co., Ltd.  http://www.e-mind.co.jp/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package jp.mosp.system.action;

import jp.mosp.common.CommonConst;
import jp.mosp.common.action.MosPAction;
import jp.mosp.common.common.MospConst;
import jp.mosp.common.common.MospException;
import jp.mosp.common.common.MospUtility;
import jp.mosp.system.dao.MKaisyaDao;
import jp.mosp.system.dto.MKaisyaDto;
import jp.mosp.system.vo.KaisyaMasterCardVo;

public class KaisyaMasterCardAction extends MosPAction {

	// コマンド
	private static final String CMD_KAISYA_MASTER_CARD_SHOW   = "S2015";	// 表示(追加)
	private static final String CMD_KAISYA_MASTER_CARD_SELECT = "S2016";	// 表示(選択)
	private static final String CMD_KAISYA_MASTER_CARD_INSERT = "S2017";	// 登録
	private static final String CMD_KAISYA_MASTER_CARD_UPDATE = "S2018";	// 更新
	private static final String CMD_KAISYA_MASTER_CARD_DELETE = "S2019";	// 削除

	/**
	 * コンストラクタ
	 */
	public KaisyaMasterCardAction() {
		super();
	}

	public void action() throws Exception {
		// DBコネクション取得
		getConnection();
		// PAYROLL権限確認
		confirmSystemAuth();
		// VOの取得		
		KaisyaMasterCardVo vo = new KaisyaMasterCardVo();
		vo.initVo(cfg, msg, cmd, aspUser, user);
		vo.setParams(request);
		// VO及びフォワード先URLの設定
		setVo(vo);
		setUrl(vo.getRetUrl());
		// DBコネクション取得
		getConnection();
		// DAOの準備
		MKaisyaDao dao;
		dao = new MKaisyaDao();
		dao.initDao(cfg, cmd, aspUser, user, conn);
		// 厚生年金基金加入表示方法プルダウンリスト作成
		vo.aryPltKikinKbn = getFundParticipationArray();
		// DTOの取得		
		MKaisyaDto dto;
		Object obj = session.getAttribute(MospConst.ATT_DTO);
		dto = obj instanceof MKaisyaDto ? (MKaisyaDto)obj : null;
		// コマンド毎の処理
		if (cmd.equals(CMD_KAISYA_MASTER_CARD_SHOW)) {
			vo.setDefaultValues();
			vo.setMode(KaisyaMasterCardVo.MODE_INSERT);
		} else if (cmd.equals(CMD_KAISYA_MASTER_CARD_SELECT)) {
			// 表示(キーで情報を検索)
			// データの取得
			dto = dao.findForKey(key1);
			chkExist(dto);
			// VOに情報をセット
			vo.setFields(dto);
			setMode(vo);
			// セッションにDTOをセット
			session.setAttribute(MospConst.ATT_DTO, dto);
		} else if (cmd.equals(CMD_KAISYA_MASTER_CARD_INSERT)) {
			// 新規登録
			dto = insert(vo);
			// セッションにDTOをセット
			session.setAttribute(MospConst.ATT_DTO, dto);
		} else if (cmd.equals(CMD_KAISYA_MASTER_CARD_UPDATE)) {
			// 更新
			dto = update(vo, dto);
			// セッションにDTOをセット
			session.setAttribute(MospConst.ATT_DTO, dto);
		} else if (cmd.equals(CMD_KAISYA_MASTER_CARD_DELETE)) {
			// 削除
			delete(vo,dto);
			// セッションにDTOをセット
			session.setAttribute(MospConst.ATT_DTO, dto);
		} else {
			throw new MospException(MospConst.EX_CMD_INVALID);
		}
	}

	/**
	 * データ挿入
	 * @param vo 対象VO
	 * @return データ挿入対象DTO
	 * @throws Exception
	 */
	private MKaisyaDto insert(KaisyaMasterCardVo vo) throws Exception {
		// パラメータの妥当性確認
		vo.validate();
		// DAOの準備
		MKaisyaDao dao = new MKaisyaDao();
		dao.initDao(cfg, cmd, aspUser, user, conn);
		// 存在チェック
		chkDuplicate(dao.findForKey(vo.getTxtJCode()), vo);
		// DTOの準備
		MKaisyaDto dto = new MKaisyaDto();
		vo.setDtoFields(dto);
		// データの挿入
		dao.insert(dto);
		// DTOの再取得
		dto = dao.findForKey(dto.getId());
		chkInsert(dto);
		// コミット
		commit();
		// モード設定
		setMode(vo);
		// メッセージ設定
		vo.setMessage(MospUtility.getMessage(msg, MospConst.MSG_INSERT, ""));
		return dto;
	}

	/**
	 * データ更新
	 * @param vo 対象VO
	 * @param dto 対象DTO
	 * @return データ挿入対象DTO
	 * @throws Exception
	 */
	private MKaisyaDto update(KaisyaMasterCardVo vo, MKaisyaDto dto) throws Exception {
		vo.setMode(KaisyaMasterCardVo.MODE_UPDATE);
		// パラメータの妥当性確認
		vo.validate();
		// DAOの準備
		MKaisyaDao dao = new MKaisyaDao();
		dao.initDao(cfg, cmd, aspUser, user, conn);
		// 排他確認
		chkExclusive(dto, dao.findForUpdate(vo.getTxtJCode()), vo);
		// DTOの準備
		vo.setDtoFields(dto);
		// データの更新
		dao.update(dto);
		// DTOの再取得
		MKaisyaDto retDto = dao.findForKey(dto.getId());
		chkUpdate(retDto);
		// コミット
		commit();
		// モード設定
		setMode(vo);
		// メッセージ設定
		vo.setMessage(MospUtility.getMessage(msg, MospConst.MSG_UPDATE, ""));
		return retDto;
	}

	/**
	 * データ削除
	 * @param vo 対象VO
	 * @param dto 対象DTO
	 * @throws Exception
	 */
	private void delete(KaisyaMasterCardVo vo,MKaisyaDto dto) throws Exception {
		// DAOの準備
		MKaisyaDao dao = new MKaisyaDao();
		dao.initDao(cfg, cmd, aspUser, user, conn);
		vo.setDtoFields(dto);
		// データの更新
		dao.delete(dto);
		// コミット
		commit();
		// メッセージ設定
		vo.setMessage(MospUtility.getMessage(msg, MospConst.MSG_DELETE, ""));
	}

	/**
	 * モード設定
	 * @param vo 対象VO
	 * @throws Exception
	 */
	private void setMode(KaisyaMasterCardVo vo) throws Exception {
		// モード設定
		if (hasSystemAuth()) {
			vo.setMode(KaisyaMasterCardVo.MODE_SYSTEM);
		} else {
			vo.setMode(KaisyaMasterCardVo.MODE_UPDATE);
		}
	}

	/**
	 * 課税対象区分取得
	 * @return 課税対象区分配列
	 */
	private String[][] getFundParticipationArray() {
		// 配列の作成
		String[][] aryPosition = new String[2][2];
		for (int i = 0; i < aryPosition.length; i++) {
			if (i == 0) {
				aryPosition[i][0] = String.valueOf(i);
				aryPosition[i][1] = CommonConst.NAM_FUND_NOT_PARTICIPATION;
			} else {
				aryPosition[i][0] =  String.valueOf(i);
				aryPosition[i][1] = CommonConst.NAM_FUND_PARTICIPATION;
			}
		}
		return aryPosition;
	}

}
